# disable stack protector, build doesn't work with it
%define _ssp_cflags     %{nil}

%define	uclibc_root	%{_prefix}/uclibc
%define	uclibc_cc	uclibc-gcc

%define	majorish	0.9.32

Summary:	A C library optimized for size useful for embedded applications
Summary(de):	C-Bibliothek, optimiert Größe, hilfreich für eingebettete Anwendungen
Name:		uClibc
Version:	%{majorish}
%define	pre	rc3.git
Release:	%mkrel 2
License:	LGPLv2.1
Group:		System/Libraries
URL:		http://uclibc.org/
Source0:	http://uclibc.org/downloads/%{name}-%{version}%{?pre:-rc3-git}.tar.xz
Source2:	uClibc-0.9.32-rc3-git-config
Patch1:		uClibc-0.9.30.1-lib64.patch
Patch2:		uClibc-0.9.32-rc3-add-rpmatch-function.patch
Patch3:		uClibc-0.9.31-add-scanf-a-flag.patch
Patch4:		uClibc-0.9.32-rc3-git-unstable-abi.patch
Patch5:		uClibc-0.9.32-rc3-git-epoll-commit-breaks-x86.patch

%description
uClibc (pronounced yew-see-lib-see) is a c library for developing
embedded linux systems. it is much smaller than the gnu c library,
but nearly all applications supported by glibc also work perfectly
with uclibc. porting applications from glibc to uclibc typically
involves just recompiling the source code. uclibc even supports
shared libraries and threading. it currently runs on standard
linux and  mmu-less (also known as uclinux) systems with support
for alpha, arm, cris, i386, i960, h8300, m68k, mips/mipsel,
powerpc, sh, sparc, and v850 processors.

if you are building an embedded linux system and you find that
glibc is eating up too much space, you should consider using
uclibc. if you are building a huge fileserver with 12 terabytes of
storage, then using glibc may make more sense. unless, for
example, that 12 terabytes will be network attached storage and
you plan to burn linux into the system's firmware...

#german
%description -l de
uClibc (ausgesprochen yew-see-lib-see) ist eine C-Bibliothek zur 
Entwicklung von eingebetteten Linux-Systemen. Es ist viel kleiner 
als die GNU C Bibliothek, aber fast alle Anwendungen die von glibc 
unterstützt werden arbeiten auch perfekt mit uClibc. 
Portierte Anwendungen von glibc nach uClibc umfassen typischerweise 
einfach das neukompilieren des Quellcodes, uClibc unterstützt auch 
freigegebene Bibliotheken und Threading. Es läuft derzeit auf 
normalem Linux und MMU-less (ebenfalls bekannt als uClinux) Systemen 
mit Unterstützung für alpha, ARM, cris, i386, i960, h8300, m68k, 
mips/mipsel, PowerPC, SH, SPARC, und v850 Prozessoren. 

Wenn du ein eingebettetes Linux-System erstellst, und findest, dass 
glibc zu viel Platz benötigt, solltest du in Erwägung ziehen, uClibc 
zu verwenden. Wenn du einen riesigen Datenserver mit 12 Terabytes 
Speicher erstellen möchtest, dann verwende glibc, um es verständlicher 
auszudrücken. Außer zum Beispiel, das die 12 Terabytes eingebundener 
Netzwerkspeicher ist und du planst, Linux in die System Firmware 
einzubrennen

%define	libname	%mklibname %{name}
%package -n	%{libname}
Summary:	%{summary}
Summary(de):	%{summary}
Group:		System/Libraries
Requires:	uClibc
%define	oldname	%mklibname %{name}
%rename		%{oldname}

%description -n	%{libname}
uClibc (pronounced yew-see-lib-see) is a c library for developing
embedded linux systems. it is much smaller than the gnu c library,
but nearly all applications supported by glibc also work perfectly
with uclibc. porting applications from glibc to uclibc typically
involves just recompiling the source code. uclibc even supports
shared libraries and threading. it currently runs on standard
linux and  mmu-less (also known as uclinux) systems with support
for alpha, arm, cris, i386, i960, h8300, m68k, mips/mipsel,
powerpc, sh, sparc, and v850 processors.

if you are building an embedded linux system and you find that
glibc is eating up too much space, you should consider using
uclibc. if you are building a huge fileserver with 12 terabytes of
storage, then using glibc may make more sense. unless, for
example, that 12 terabytes will be network attached storage and
you plan to burn linux into the system's firmware...

#german
%description -n	%{libname} -l de
uClibc (ausgesprochen yew-see-lib-see) ist eine C-Bibliothek zur 
Entwicklung von eingebetteten Linux-Systemen. Es ist viel kleiner 
als die GNU C Bibliothek, aber fast alle Anwendungen die von glibc 
unterstützt werden arbeiten auch perfekt mit uClibc. 
Portierte Anwendungen von glibc nach uClibc umfassen typischerweise 
einfach das neukompilieren des Quellcodes, uClibc unterstützt auch 
freigegebene Bibliotheken und Threading. Es läuft derzeit auf 
normalem Linux und MMU-less (ebenfalls bekannt als uClinux) Systemen 
mit Unterstützung für alpha, ARM, cris, i386, i960, h8300, m68k, 
mips/mipsel, PowerPC, SH, SPARC, und v850 Prozessoren. 

Wenn du ein eingebettetes Linux-System erstellst, und findest, dass 
glibc zu viel Platz benötigt, solltest du in Erwägung ziehen, uClibc 
zu verwenden. Wenn du einen riesigen Datenserver mit 12 Terabytes 
Speicher erstellen möchtest, dann verwende glibc, um es verständlicher 
auszudrücken. Außer zum Beispiel, das die 12 Terabytes eingebundener 
Netzwerkspeicher ist und du planst, Linux in die System Firmware 
einzubrennen

%define	libdev	%mklibname %{name} -d
%package -n	%{libdev}
Summary:	Development files & libraries for uClibc
Summary(de):	Entwicklerdateien für uClibc
Group:		Development/C
Requires:	%{libname} = %{majorish}
%rename		%{name}-devel
%define	libstat	%mklibname %{name} -d -s
%rename		%{libstat}
%rename		%{name}-static-devel
Provides:	libc-static

%description -n	%{libdev}
Small libc for building embedded applications.

#german
%description -n	%{libdev} -l de
Kleine libc zum bilden ein eigebetteter Anwendungen.

%prep
%setup -q -n %{name}-%{version}%{?pre:-rc3-git}
#%%patch1 -p1 -b .lib64~
%patch2 -p1 -b .rpmatch~
%patch3 -p1 -b .a_flag~
%patch4 -p1 -b .abi~
%ifarch %{ix86}
%patch5 -p1 -R -b .epoll~
%endif

%define arch %(echo %{_arch} | sed -e 's/ppc/powerpc/')
cat %{SOURCE2} |sed \
	-e "s|@CFLAGS@|%{optflags} %{ldflags} -muclibc -Wl,-rpath=%{uclibc_root}/%{_lib} -Wl,-rpath=%{uclibc_root}%{_libdir}|g" \
	-e 's|@ARCH@|%{arch}|g' \
	-e 's|@LIB@|%{_lib}|g' \
	-e 's|@PREFIX@|%{uclibc_root}|g' \
	>> .config

%build
yes "" | make oldconfig V=1

# parallel build breaks..
make VERBOSE=1 CPU_CFLAGS="" all utils

%check
exit 0
ln -snf %{_includedir}/{asm,asm-generic,linux} test
ln -snf %{buildroot}%{uclibc_root} install_dir
# This test relies on /etc/ethers being present to pass, so we'll skip it by
# removing it
rm -f test/inet/tst-ethers*
%make check VERBOSE=1 || /bin/true 

%install
#(proyvind): to prevent possible interference...
export LD_LIBRARY_PATH=
make VERBOSE=1 PREFIX=%{buildroot} install
make -C utils VERBOSE=1 PREFIX=%{buildroot} utils_install

# be sure that we don't package any backup files
find %{buildroot} -name \*~|xargs rm -f

install -d %{buildroot}%{_bindir}
# using 'rpm --eval' here for multilib purposes..
#TODO: figure out binutils --sysroot + multilib in binutils package?
cat > %{buildroot}%{_bindir}/%{uclibc_cc} << EOF
#!/bin/sh
export C_INCLUDE_PATH="\$(rpm --eval %%{uclibc_root}%%{_includedir}):\$(gcc -print-search-dirs|grep install:|cut -d\  -f2)include"
export LD_RUN_PATH="\$(rpm --eval %%{uclibc_root}/%%{_lib}:%%{uclibc_root}%%{_libdir})"
export LIBRARY_PATH="\$LD_RUN_PATH"
exec gcc -muclibc \$@
EOF
chmod +x %{buildroot}%{_bindir}/%{uclibc_cc}

install -d %{buildroot}%{_sysconfdir}/rpm/macros.d
cat > %{buildroot}%{_sysconfdir}/rpm/macros.d/uclibc.macros << EOF
%%uclibc_root	%{uclibc_root}
%%uclibc_cc	%{uclibc_cc}
%%uclibc_cflags	%%{optflags} -fno-stack-protector
EOF

#(peroyvind) rpm will make these symlinks relative
ln -snf %{_includedir}/{asm,asm-generic,linux} %{buildroot}%{uclibc_root}%{_includedir}

# crack hack to get uclibc working with chroot within uclibc root..
#mkdir -p %{buildroot}%{uclibc_root}%{uclibc_root}
#ln -s ../../%{_lib} %{buildroot}%{uclibc_root}%{uclibc_root}/%{_lib}

%if "%{_lib}" == "lib64"
ln -s ld64-uClibc.so.%{version} %{buildroot}%{uclibc_root}/%{_lib}/ld64-uClibc.so.0
%else
ln -s ld-uClibc.so.%{version} %{buildroot}%{uclibc_root}/lib/ld-uClibc.so.0
%endif

for dir in /bin /sbin %{_prefix} %{_bindir} %{_sbindir}; do
	mkdir -p %{buildroot}%{uclibc_root}$dir
done

mkdir -p %{buildroot}%{uclibc_root}%{_sysconfdir}
touch %{buildroot}%{uclibc_root}%{_sysconfdir}/ld.so.{conf,cache}

%posttrans
 %{uclibc_root}/sbin/ldconfig

%triggerin -- %{uclibc_root}/lib/*.so.*, %{uclibc_root}/lib64/*.so.*, %{uclibc_root}%{_prefix}/lib/*.so.*, %{uclibc_root}%{_prefix}/lib64/*.so.*
%{uclibc_root}/sbin/ldconfig -X

%clean
rm -rf $RPM_BUILD_ROOT


%files
%doc README
%dir %{uclibc_root}/bin
%dir %{uclibc_root}/sbin
%dir %{uclibc_root}%{_bindir}
%dir %{uclibc_root}%{_sbindir}
%dir %{uclibc_root}%{_sysconfdir}
%verify(not md5 size mtime) %config(noreplace) %{uclibc_root}%{_sysconfdir}/ld.so.conf
%ghost %{uclibc_root}%{_sysconfdir}/ld.so.cache
%{uclibc_root}%{_bindir}/getconf
%{uclibc_root}%{_bindir}/ldd
%{uclibc_root}/sbin/ldconfig
#%dir %{uclibc_root}%{uclibc_root}
#%dir %{uclibc_root}%{uclibc_root}/%{_lib}
%if "%{_lib}" == "lib64"
%{uclibc_root}/%{_lib}/ld64-uClibc.so.0
#%{uclibc_root}%{uclibc_root}/%{_lib}/ld64-uClibc.so.0
%else
%{uclibc_root}/lib/ld-uClibc.so.0
#%{uclibc_root}%{uclibc_root}/lib/ld-uClibc.so.0
%endif

%files -n %{libname}
%dir %{uclibc_root}
%dir %{uclibc_root}%{_prefix}
%dir %{uclibc_root}/%{_lib}
%dir %{uclibc_root}%{_libdir}
%ifnarch %{sparcx}
%{uclibc_root}/%{_lib}/*-*%{version}%{?pre:-%(echo %{pre}|sed -e 's#\.#-#')}.so
%{uclibc_root}/%{_lib}/*.so.%{version}
%endif

%files -n %{libdev}
%doc docs/* Changelog TODO
%{_bindir}/%{uclibc_cc}
%{_sysconfdir}/rpm/macros.d/uclibc.macros
%{uclibc_root}%{_includedir}
%{uclibc_root}%{_libdir}/crt1.o
%{uclibc_root}%{_libdir}/crti.o
%{uclibc_root}%{_libdir}/crtn.o
%ifnarch %{sparcx}
%{uclibc_root}%{_libdir}/Scrt1.o
%{uclibc_root}%{_libdir}/librt.so
%{uclibc_root}%{_libdir}/libnsl.so
%{uclibc_root}%{_libdir}/libpthread.so
%{uclibc_root}%{_libdir}/libc.so
%{uclibc_root}%{_libdir}/libcrypt.so
%{uclibc_root}%{_libdir}/libdl.so
%{uclibc_root}%{_libdir}/libm.so
%{uclibc_root}%{_libdir}/libresolv.so
%{uclibc_root}%{_libdir}/libutil.so
%endif
%{uclibc_root}%{_libdir}/lib*.a
%{uclibc_root}%{_libdir}/uclibc_nonshared.a


%changelog
* Tue Feb 28 2012 Neal <nealbrks0 at gmail dot com> 0.9.32-2pclos2012
- process

* Tue Feb 28 2012 leiche <meisssw01 at gmail.com> 0.9.32-2pclos2012
- rebuild from 64 for 32
- add german description
